package io.github.lonamiwebs.overgram.tl;

import io.github.lonamiwebs.overgram.utils.BinaryReader;
import io.github.lonamiwebs.overgram.utils.BinaryWriter;

public abstract class TLObject {
    public abstract void serialize(final BinaryWriter writer);

    public abstract void deserialize(final BinaryReader reader) throws ClassNotFoundException;

    public byte[] serializeToBytes() {
        final BinaryWriter writer = new BinaryWriter();
        serialize(writer);
        return writer.toBytes();
    }
}
